<?php 

include_once(DIR_SYSTEM . '../settings/settings.php');
class ControllerExtensionPaymentWorldNetHPP extends Controller {
	private $error = array(); 
	
	public function index() {
		$this->load->language('extension/payment/'.$GLOBALS['oc_file_name']);
		$filename = $GLOBALS['oc_file_name'];
		$this->document->setTitle($this->language->get('heading_title'));
		$this->load->model('setting/setting');
		
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->model_setting_setting->editSetting($this->language->get('text_filename'), $this->request->post);				
			$this->session->data['success'] = $this->language->get('text_success');
			$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=payment', true));
		}
        $data['text_gateway']  = $this->language->get('text_gateway');
        $data['text_hppcurrency']  = $this->language->get('text_hppcurrency');
        $data['hpp_currency1'] = $hpp_currency1 = $this->language->get('text_terminalcur').'1' ;
        $data['hpp_currency2'] = $hpp_currency2 = $this->language->get('text_terminalcur').'2' ;
        $data['hpp_currency3'] = $hpp_currency3 = $this->language->get('text_terminalcur').'3' ;
        $data['hpp_terminal1'] = $hpp_terminal1 = $this->language->get('text_terminalid').'1';
        $data['hpp_terminal2'] = $hpp_terminal2 = $this->language->get('text_terminalid').'2';
        $data['hpp_terminal3'] = $hpp_terminal3 = $this->language->get('text_terminalid').'3';
        $data['hpp_secret1']   = $hpp_secret1 = $this->language->get('text_terminalsecret').'1';
        $data['hpp_secret2']   = $hpp_secret2 = $this->language->get('text_terminalsecret').'2';
        $data['hpp_secret3']   = $hpp_secret3 = $this->language->get('text_terminalsecret').'3';
        $data['filename'] =  $filename; 

        $data['text_filename'] = $hpp_filename = $this->language->get('text_filename');
		$data['heading_title'] = $this->language->get('heading_title');
		$data['text_edit'] = $this->language->get('text_edit');
        $data['text_hppstatus'] = $this->language->get('text_hppstatus');
        $data['text_terminalcur'] = $this->language->get('text_terminalcur');
        $data['text_terminalsecret'] = $this->language->get('text_terminalsecret');
        $data['text_terminalid'] = $this->language->get('text_terminalid');
        $data['text_terminaltest'] = $this->language->get('text_terminaltest');
        $data['text_terminalgateway'] = $hpp_gateway = $this->language->get('text_terminalgateway');
        
        $data['text_send_receipt'] = $this->language->get('text_send_receipt');
        $data['text_status_success'] = $this->language->get('text_status_success');
        $data['text_status_declined'] = $this->language->get('text_status_declined');
        $data['text_status_failed'] = $this->language->get('text_status_failed');
        $data['text_sort_order'] = $this->language->get('text_sort_order');
       
		$data['text_success'] = $this->language->get('text_success');
		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_true'] = $this->language->get('text_true');
		$data['text_false'] = $this->language->get('text_false');
		
		$data['tab_account'] = $this->language->get('tab_account');
		$data['tab_order_status'] = $this->language->get('tab_order_status');
		$data['entry_gateway'] = $this->language->get('entry_gateway');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_test'] = $this->language->get('entry_test');
		$data['entry_currency1'] = $this->language->get('entry_currency1');
		$data['entry_currency1_tip'] = $this->language->get('entry_currency1_tip');
		$data['entry_terminal1'] = $this->language->get('entry_terminal1');
		$data['entry_terminal1_tip'] = $this->language->get('entry_terminal1_tip');
		$data['entry_secret1'] = $this->language->get('entry_secret1');
		$data['entry_secret1_tip'] = $this->language->get('entry_secret1_tip');
		$data['entry_currency2'] = $this->language->get('entry_currency2');
		$data['entry_terminal2'] = $this->language->get('entry_terminal2');
		$data['entry_secret2'] = $this->language->get('entry_secret2');
		$data['entry_currency3'] = $this->language->get('entry_currency3');
		$data['entry_terminal3'] = $this->language->get('entry_terminal3');
		$data['entry_secret3'] = $this->language->get('entry_secret3');
		$data['entry_order_status'] = $this->language->get('entry_order_status');
		$data['entry_send_receipt'] = $this->language->get('entry_send_receipt');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$data['error_permission'] = $this->language->get('error_permission');
		$data['error_terminal1'] = $this->language->get('error_terminal1');
		$data['error_secret1'] = $this->language->get('error_secret1');
		$data['error_secret1_tip'] = $this->language->get('error_secret1_tip');
		$data['entry_status_success'] = $this->language->get('entry_status_success');
		$data['entry_status_declined'] = $this->language->get('entry_status_declined');
		$data['entry_status_failed'] = $this->language->get('entry_status_failed');
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

 		if (isset($this->error['warning'])) $data['error_warning'] = $this->error['warning'];
		else $data['error_warning'] = '';

 		if (isset($this->error['gateway'])) $data['error_gateway'] = $this->error['gateway'];
		else $data['error_gateway'] = '';

  		if (isset($this->error['terminal1'])) $data['error_terminal1'] = $this->error['terminal1'];
		else $data['error_terminal1'] = '';

 		if (isset($this->error['secret1'])) $data['error_secret1'] = $this->error['secret1'];
		else $data['error_secret1'] = '';

  		$data['breadcrumbs'] = array();

   		$data['breadcrumbs'][] = array(
	       		'href'      => HTTPS_SERVER . 'index.php?route=common/home&token=' . $this->session->data['token'],
	       		'text'      => $this->language->get('text_home'),
	      		'separator' => FALSE
   		);

   		$data['breadcrumbs'][] = array(
	       		'href'      => HTTPS_SERVER . 'index.php?route=extension/payment&token=' . $this->session->data['token'],
	       		'text'      => $this->language->get('text_payment'),
	      		'separator' => ' :: '
   		);

   		$data['breadcrumbs'][] = array(
	       		'href'      => HTTPS_SERVER . 'index.php?route=extension/payment/'.$this->language->get('text_filename').'&token=' . $this->session->data['token'],
	       		'text'      => $this->language->get('heading_title'),
	      		'separator' => ' :: '
   		);
        
        $data['action'] = $this->url->link('extension/payment/'.$this->language->get('text_filename'), 'token=' . $this->session->data['token'], true);
		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=payment', true);

				
		if (isset($this->request->post[$hpp_gateway])) $data[$hpp_gateway] = $this->request->post[$hpp_gateway];
		else $data[$hpp_gateway] = $this->config->get($hpp_gateway);

		if (isset($this->request->post[$hpp_currency1])) $data[$hpp_currency1] = $this->request->post[$hpp_currency1];
		else $data[$hpp_currency1] = $this->config->get($hpp_currency1);

		if (isset($this->request->post[$hpp_terminal1])) $data[$hpp_terminal1] = $this->request->post[$hpp_terminal1];
		else $data[$hpp_terminal1] = $this->config->get($hpp_terminal1);

		if (isset($this->request->post[$hpp_secret1])) $data[$hpp_secret1] = $this->request->post[$hpp_secret1];
		else $data[$hpp_secret1] = $this->config->get($hpp_secret1);

		if (isset($this->request->post[$hpp_currency2])) $data[$hpp_currency2] = $this->request->post[$hpp_currency2];
		else $data[$hpp_currency2] = $this->config->get($hpp_currency2);

		if (isset($this->request->post[$hpp_terminal2])) $data[$hpp_terminal2] = $this->request->post[$hpp_terminal2];
		else $data[$hpp_terminal2] = $this->config->get($hpp_terminal2);
		
		if (isset($this->request->post[$hpp_secret2])) $data[$hpp_secret2] = $this->request->post[$hpp_secret2];
		else $data[$hpp_secret2] = $this->config->get($hpp_secret2);

		if (isset($this->request->post[$hpp_currency3])) $data[$hpp_currency3] = $this->request->post[$hpp_currency3];
		else $data[$hpp_currency3] = $this->config->get($hpp_currency3);

		if (isset($this->request->post[$hpp_terminal3])) $data[$hpp_terminal3] = $this->request->post[$hpp_terminal3];
		else $data[$hpp_terminal3] = $this->config->get($hpp_terminal3);

		if (isset($this->request->post[$hpp_secret3])) $data[$hpp_secret3] = $this->request->post[$hpp_secret3];
		else $data[$hpp_secret3] = $this->config->get($hpp_secret3);

		if (isset($this->request->post[$this->language->get('text_terminaltest')])) $data[$this->language->get('text_terminaltest')] = $this->request->post[$this->language->get('text_terminaltest')];
		else $data[$this->language->get('text_terminaltest')] = $this->config->get($this->language->get('text_terminaltest'));

		if (isset($this->request->post[$this->language->get('text_status_success')])) $data[$this->language->get('text_status_success')] = $this->request->post[$this->language->get('text_status_success')];
		else $data[$this->language->get('text_status_success')] = $this->config->get($this->language->get('text_status_success'));

		if (isset($this->request->post[$this->language->get('text_status_declined')])) $data[$this->language->get('text_status_declined')] = $this->request->post[$this->language->get('text_status_declined')];
		else $data[$this->language->get('text_status_declined')] = $this->config->get($this->language->get('text_status_declined'));

		if (isset($this->request->post[$this->language->get('text_status_failed')])) $data[$this->language->get('text_status_failed')] = $this->request->post[$this->language->get('text_status_failed')];
		else $data[$this->language->get('text_status_failed')] = $this->config->get($this->language->get('text_status_failed'));

		$this->load->model('localisation/order_status');
		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post[$this->language->get('text_hppstatus')])) $data[$this->language->get('text_hppstatus')] = $this->request->post[$this->language->get('text_hppstatus')];
		else $data[$this->language->get('text_hppstatus')] = $this->config->get($this->language->get('text_hppstatus'));

		if (isset($this->request->post[$this->language->get('text_send_receipt')])) $data[$this->language->get('text_send_receipt')] = $this->request->post[$this->language->get('text_send_receipt')];
		else $data[$this->language->get('text_send_receipt')] = $this->config->get($this->language->get('text_send_receipt'));

		if (isset($this->request->post[$this->language->get('text_sort_order')])) $data[$this->language->get('text_sort_order')] = $this->request->post[$this->language->get('text_sort_order')];
		else $data[$this->language->get('text_sort_order')] = $this->config->get($this->language->get('text_sort_order'));

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/payment/'.$hpp_filename.'.tpl', $data));
	}

	private function validate() {
		$filename = $GLOBALS['oc_file_name'];
		if (!$this->user->hasPermission('modify', 'extension/payment/'.$filename)) $this->error['warning'] = $this->language->get('error_permission');
		if (!$this->request->post[$filename.'_gateway']) $this->error['gateway'] = $this->language->get('error_gateway');
		if (!$this->request->post[$filename.'_terminal1']) $this->error['terminal1'] = $this->language->get('error_terminal1');
		if (!$this->request->post[$filename.'_secret1']) $this->error['secret1'] = $this->language->get('error_secret1');
		if (!$this->error) return TRUE;
		else return FALSE;
	}
}
?>
