<?php
  
 $inipath = DIR_SYSTEM . '../settings/settings.ini';
 $ini_array = parse_ini_file($inipath);
   


// Text 

$_['text_payment']            = 'Payment';
$_['text_success']            = 'Settings successfully saved.';
$_['text_yes']                = 'Yes';
$_['text_no']                 = 'No';
$_['text_enabled']            = 'Enabled';
$_['text_disabled']           = 'Disabled';
$_['text_true']               = 'True';
$_['text_false']              = 'False';
 
// Currency
$_['text_gateway']       =  $ini_array["gateway"];
$_['text_hppcurrency']   =  $ini_array["currency_code"];
$_['text_hppbrandname']  =  $ini_array["brand_name"];
$_['text_shortname']     =  $ini_array["short_name"];
$_['text_logo']          =$ini_array["mainlogo"];
$gateway_text = ucfirst($_['text_shortname']); 
$_['text_filename']      =  $_['text_shortname'].'hpp';
$_['text_hppstatus']     =  $_['text_filename'].'_status';
$_['text_terminalcur']   =  $_['text_filename'].'_currency';
$_['text_terminalsecret'] = $_['text_filename'].'_secret';
$_['text_terminalid']      = $_['text_filename'].'_terminal';
$_['text_terminaltest']    = $_['text_filename'].'_test';
$_['text_terminalgateway'] = $_['text_filename'].'_gateway';
$_['text_send_receipt'] = $_['text_filename'].'_send_receipt';
$_['text_status_success'] = $_['text_filename'].'_status_success';
$_['text_status_declined'] = $_['text_filename'].'_status_declined';
$_['text_status_failed'] = $_['text_filename'].'_status_failed';
$_['text_sort_order'] = $_['text_filename'].'_sort_order';
$_['text_edit']               = 'Edit '.$_['text_shortname'].' plug-in settings';
$_['text_'.$_['text_filename']] = '<img src="view/image/payment/'.$_['text_logo'].'" alt="'.$_['text_hppbrandname'].'" title="'.$_['text_hppbrandname'].'" style="border: 1px solid #EEEEEE;" /></a>';
// Heading
$_['heading_title']           = $gateway_text.' (Hosted Payment Page)';

// Tabs
$_['tab_account']	 = 'Accounts';
$_['tab_order_status']	 = 'Order status';

     
// Accounts Tab
$_['entry_gateway']      = $gateway_text.' Gateway:';
$_['entry_status']       = 'Status:';
$_['entry_test']         = 'Test Account:';
$_['entry_currency1']    = 'Primary Currency:';
$_['entry_currency1_tip']= 'This is the currency of your '.$gateway_text.'  Terminal ID (or one of your terminal ID\'s if you have multiple currencies).';
$_['entry_terminal1']    = 'Primary Terminal ID:';
$_['entry_terminal1_tip']= 'This is the '.$gateway_text.' Terminal ID for that currency.';
$_['entry_secret1']      = 'Primary Shared Secret:';
$_['entry_secret1_tip']  = 'This is the shared secret for that Terminal ID, exactly as you set it in the '.$gateway_text.' SelfCare System.';
$_['entry_currency2']    = 'Secondary Currency:';
$_['entry_terminal2']    = 'Secondary Terminal ID:';
$_['entry_secret2']      = 'Secondary Shared Secret:';
$_['entry_currency3']    = 'Tertiary Currency:';
$_['entry_terminal3']    = 'Tertiary Terminal ID:';
$_['entry_secret3']      = 'Tertiary Shared Secret:';
$_['entry_order_status'] = 'Order Status:';
$_['entry_send_receipt'] = 'Send a '.$gateway_text.' receipt?';
$_['entry_send_receipt_tip'] = 'If set to Yes then '.$gateway_text.' will email a credit card receipt to the cardholder. This is not the same as the order confirmation email from OpenCart.';
$_['entry_sort_order']   = 'Sort Order:';


$_['entry_status_success']   = 'Success:';
$_['entry_status_declined']   = 'Declined:';
$_['entry_status_failed']   = 'Failed:';


// Error
$_['error_permission']   = 'Warning: You do not have permission to modify the '.$gateway_text.' settings!';
$_['error_terminal1']    = 'Primary '.$gateway_text.' Terminal ID required!';
$_['error_secret1']      = 'Primary Shared Secret required!';
?>
